package rabinizer.exec;
import java.util.*;

import rabinizer.formulas.*;

public class KRabinAcceptanceCondition {
	
	
	public Set<Tuple<Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>, Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>>> condition = null;       
	
		
	KRabinAcceptanceCondition(KRabinAutomaton ra){
		condition = new HashSet<Tuple<Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>, Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>>>();
		List<Tuple<Map<Tuple<Tuple<Formula, KState>, Tuple<Formula, KState>>, ValuationSet>, List<Map<Tuple<Tuple<Formula, KState>, Tuple<Formula, KState>>, ValuationSet>>>> grac=ra.condition;
		
		for (int i = 0; i < grac.size(); i++) {
			Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet> fC = new HashMap<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>(); 
			Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet> iC = new HashMap<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>(); 

			for(Map.Entry<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet> edge : ra.edges.entrySet()){
				if(edge.getKey().right.right.get(i)==0){
					if(!(edge.getKey().left.right.get(i)==0)){
						Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>> sta =edge.getKey();
						ValuationSet vs2=edge.getValue();
						
						iC.put(sta,vs2);
					}
					else{
						//when it is from 0 to 0
						if (grac.get(i).right.size()==1){
							Tuple<Tuple<Formula, KState>,Tuple<Formula, KState>> st = new Tuple<Tuple<Formula, KState>,Tuple<Formula, KState>> (edge.getKey().left.left,edge.getKey().right.left);
							for (Valuation v:edge.getValue()){
							
								if(grac.get(i).right.get(0).containsKey(st) && (grac.get(i).right.get(0).get(st).contains(v))){
									if(iC.containsKey(edge.getKey())){
										ValuationSet vs = iC.get(edge.getKey());
										vs.add(v);
										iC.put(edge.getKey(), vs);
									}
									else{
										ValuationSet vs = new ValuationSet();
										vs.add(v);
										iC.put(edge.getKey(), vs);
									}
								}
									
							}
						}
					}
				}
				Tuple<Tuple<Formula, KState>,Tuple<Formula, KState>> st2 = new Tuple<Tuple<Formula, KState>,Tuple<Formula, KState>> (edge.getKey().left.left,edge.getKey().right.left);
				
				if(grac.get(i).left.containsKey(st2)){
					for(Valuation v: edge.getValue()){
						if(grac.get(i).left.get(st2).contains(v)){
							if(fC.containsKey(edge.getKey())){
								ValuationSet vs = fC.get(edge.getKey());
								vs.add(v);
								fC.put(edge.getKey(), vs);
							}
							else{
								ValuationSet vs = new ValuationSet();
								vs.add(v);
								fC.put(edge.getKey(), vs);
							}
						}
					}
				}
			}
			condition.add(new Tuple<Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>, Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>>(fC,iC));
				
		}
			
	}
		
		
		
		
	
	public String toString() {
        int rpc = 0;
        String r = "Rabin pair count: "+condition.size()+"\n";
        for (Tuple<Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>, Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>> pair : condition) {
            r += "Pair "+(++rpc)+":\n";
        	r += pairToString(pair);
        }
        return r;
    }
    
	
	
    private String pairToString(Tuple<Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>, Map<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet>> pair) {
    	String r = "[\n";
        for (Map.Entry<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet> avoidRabinState : pair.left.entrySet())
            r += " "+avoidRabinState+"\n";
        r += "]\n[\n";
        for (Map.Entry<Tuple<Tuple<Tuple<Formula, KState>,List<Integer>>, Tuple<Tuple<Formula, KState>,List<Integer>>>, ValuationSet> reachRabinState : pair.right.entrySet()) {
        	//r += " [\n";
        	//for (Tuple<Formula, KState> reachGenRabinState : reachRabinState.getKey())
        		r += "  "+reachRabinState+"\n";
        	//r += " ]" + reachRabinState.getValue()+"\n";
        }
        r += "]\n";
        return r;
    }
    
    public int size() {
    	return condition.size();
    }
    
  
}
