package tests;

import static org.junit.Assert.*;

import java.io.StringReader;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;

import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;

import rabinizer.formulas.Formula;
import rabinizer.parser.LTLParser;

@RunWith(value = Parameterized.class)
public class RemoveConstantCurrentAssertions {

	private String input;
	private String expected;	
	
	public RemoveConstantCurrentAssertions(String input, String expected) {
		this.input = input;
		this.expected = expected;
	}

	@Parameters
	public static Collection<Object[]> data() {
		Object[][] data = new Object[][] { 
                    { "false | true & G (a & F b)", "G (a & F b)" },
                    { "F a | X b", "F a | X b" },
                    { "G a U X G b", "G a U X G b" },
                                
                    { "true & X b", "X b" },
                    { "(true & X b) | (false & X X a)", "X b" },
                    { "X a & G b", "X a & G b" },
                    { "true & (false | X c)", "X c" },
		};
		return Arrays.asList(data);
	}

	@Test
	public void pushTest() {
		System.out.println(this.getClass().getCanonicalName()+" : "+input+" and "+expected);
		
		LTLParser parser = new LTLParser(new StringReader(input));
		Formula inf = null;
		try { inf = parser.parse(); }
		catch (Exception e) { assertTrue(false); }
		
		parser.ReInit(new StringReader(expected));
		Formula exf = null;
		try { exf = parser.parsePreviousAtoms(); }
		catch (Exception e) { assertTrue(false); }
		
		assertTrue(exf.equals(inf.removeConstantCurrentAssertions()));
	}
}
